//
//  TYExtraButtonManager.h
//  Tukuyomi
//
//  Created by toveta on Tue Jun 18 2002.
//  Copyright (c) 2002 toveta All rights reserved.
//
/*
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND 
 * &ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <Cocoa/Cocoa.h>
#import "TYRespondRectManager.h"

enum {
    TYButtonUnInitialize=-1,
    TYButtonNoSelected=0,
};

@class TYCellImage;

@interface TYExtraButtonManager : TYRespondRectManager {
    NSImage *sourceImage;
    NSString *noSelectAction;
    BOOL isOverlayButton; // 摜{^ܗLtO
    BOOL isSpriteButton; // XvCg{^ܗLtO
    BOOL isCustomSel; // JX^I[htO
}
-(id)initWithStageManager:(TYStageManager*)manager sourceImage:(NSImage*)sImage;
-(void)addButton:(NSNumber*)no x:(NSNumber*)x y:(NSNumber*)y width:(NSNumber*)width height:(NSNumber*)height selx:(NSNumber*)selx sely:(NSNumber*)sely;
-(void)addSpriteButton:(NSNumber*)no spriteNo:(NSNumber*)sNo appendAction:(NSString*)aString;
-(void)addCselButton:(NSNumber*)no selectionNo:(NSNumber*)sNo image:(TYCellImage*)image point:(NSPoint)aPoint;
-(void)setNoSelectAction:(NSString*)aStr;

-(void)initialButtonImage; // override
-(BOOL)changeSelection:(int)index; // override

-(NSImage*)sourceImage;

@end

@interface TYButton : NSObject <NSCopying>{
    NSNumber *idno;
    NSImage *selectedImage;
    NSRect drawRect;
}
-(id)initWithID:(NSNumber*)no selectedImage:selImage rect:(NSRect)aRect;
-(void)drawWithSelect:(BOOL)aBool;
-(NSRect*)boundingRect;
-(NSNumber*)idNo;
-(NSString*)description; // override
@end

@interface TYSpriteButton : NSObject{
    NSNumber *idno;
    NSNumber *spriteNo;
    NSString *appendAction;
}
-(id)initWithID:(NSNumber*)no spriteNo:(NSNumber*)sNo appendAction:(NSString*)string;
-(NSNumber*)idNo;
-(int)spriteNo;
-(NSString*)appendString;
@end

@interface TYCselButton : NSObject{
    NSNumber *idno;
    int selNo;
    TYCellImage *strImage;
    NSPoint drawPoint;
}
-(id)initWithID:(NSNumber*)no selctionNo:(int)sNo image:(TYCellImage*)image point:(NSPoint)aPoint;
-(void)drawWithSelect:(BOOL)aBool;
-(NSNumber*)idNo;
-(int)cselNo;
@end
